<table
  mat-table
  [dataSource]="users"
  class="mat-elevation-z0"
  multiTemplateDataRows
>
  <ng-container matColumnDef="name">
    <th mat-header-cell *matHeaderCellDef>
      {{ 'adminusers.firstname' | translate }}
    </th>
    <td mat-cell *matCellDef="let user">{{ user.firstName }}</td>
  </ng-container>

  <ng-container matColumnDef="lastName">
    <th mat-header-cell *matHeaderCellDef>
      {{ 'adminusers.lastname' | translate }}
    </th>
    <td mat-cell *matCellDef="let user">{{ user.lastName }}</td>
  </ng-container>

  <ng-container matColumnDef="email">
    <th mat-header-cell *matHeaderCellDef>
      {{ 'adminusers.email' | translate }}
    </th>
    <td mat-cell *matCellDef="let user">{{ user.email }}</td>
  </ng-container>

  <ng-container matColumnDef="organization">
    <th mat-header-cell *matHeaderCellDef>
      {{ 'adminusers.organization' | translate }}
    </th>
    <td mat-cell *matCellDef="let user">
      {{ user.organization.organizationName }}
    </td>
  </ng-container>

  <ng-container matColumnDef="deactivate">
    <th mat-header-cell *matHeaderCellDef>
      {{ 'adminusers.deactivated' | translate }}
    </th>
    <td mat-cell *matCellDef="let user">
      <mat-slide-toggle
        (click)="$event.stopPropagation()"
        class="example-margin"
        [checked]="isDeactivated(user)"
        (change)="deactivate(user)"
      >
      </mat-slide-toggle>
    </td>
  </ng-container>

  <ng-container matColumnDef="action">
    <th mat-header-cell *matHeaderCellDef>
      {{ 'adminusers.action' | translate }}
    </th>
    <td mat-cell *matCellDef="let user" (click)="$event.stopPropagation()">
      <i class="material-icons action-buttons" (click)="editUser(user)">edit</i>
      <!-- <i class="material-icons action-buttons" (click)="deactivate(user)">build</i> -->
      <i class="material-icons action-buttons" (click)="deleteUser(user)"
        >delete</i
      >
    </td>
  </ng-container>

  <ng-container matColumnDef="expandedDetail">
    <td
      mat-cell
      *matCellDef="let element"
      [attr.colspan]="columnsToDisplay.length"
    >
      <div
        class="example-element-detail"
        [ngClass]="{ 'element-expanded': element === expandedElement }"
        [@detailExpand]="element === expandedElement ? 'expanded' : 'collapsed'"
      >
        <div class="user-info">
          <div class="user-single-info">
            <span class="user-single-into-title"
              >{{ 'adminusers.lastlogin' | translate }}:</span
            >
            {{ dateFormatter.getDateInRightFormat(element.lastLogin) }}
          </div>
          <div class="user-single-info">
            <span class="user-single-into-title"
              >{{ 'adminusers.registrationtime' | translate }}:</span
            >
            {{ dateFormatter.getDateInRightFormat(element.registrationDate) }}
          </div>
          <div class="user-single-info">
            <span class="user-single-into-title"
              >{{ 'adminusers.numberofjobs' | translate }}:</span
            >
            {{ element.numberCurrentlyRunningJobs }}
          </div>
          <div class="user-single-info">
            <span class="user-single-into-title"
              >{{ 'adminusers.numberoffinishedjobs' | translate }}:</span
            >
            {{ element.numberFinishedJobs }}
          </div>
        </div>
      </div>
    </td>
  </ng-container>

  <tr mat-header-row *matHeaderRowDef="columnsToDisplay"></tr>
  <tr
    mat-row
    *matRowDef="let element; columns: columnsToDisplay"
    class="example-element-row"
    [style.backgroundColor]="element === expandedElement ? '#eeeeee' : ''"
    [class.example-expanded-row]="expandedElement === element"
    (click)="expandedElement = expandedElement === element ? null : element"
  ></tr>
  <tr
    mat-row
    *matRowDef="let row; columns: ['expandedDetail']"
    class="example-detail-row"
  ></tr>
</table>

<mat-card
  class="card mobileView"
  *ngFor="let user of users"
  (click)="itemClicked(user)"
>
  <div class="card-item">
    <span class="mobileViewHint"
      >{{ 'adminusers.firstname' | translate }}:
    </span>
    {{ user.firstName }}
  </div>
  <div class="card-item">
    <span class="mobileViewHint"
      >{{ 'adminusers.lastname' | translate }}:
    </span>
    {{ user.lastName }}
  </div>
  <div class="card-item">
    <span class="mobileViewHint">{{ 'adminusers.email' | translate }}: </span>
    {{ user.email }}
  </div>
  <div class="card-item">
    <span class="mobileViewHint"
      >{{ 'adminusers.organization' | translate }}:
    </span>
    {{ user.organization.organizationName }}
  </div>

  <div class="card-item">
    <span class="mobileViewHint"
      >{{ 'adminusers.lastlogin' | translate }}:
    </span>
    {{ dateFormatter.getDateInRightFormat(user.lastLogin) }}
  </div>
  <div class="card-item">
    <span class="mobileViewHint"
      >{{ 'adminusers.registrationtime' | translate }}:
    </span>
    {{ dateFormatter.getDateInRightFormat(user.registrationDate) }}
  </div>
  <div class="card-item">
    <span class="mobileViewHint"
      >{{ 'adminusers.numberofjobs' | translate }}:
    </span>
    {{ user.numberCurrentlyRunningJobs }}
  </div>
  <div class="card-item">
    <span class="mobileViewHint"
      >{{ 'adminusers.numberoffinishedjobs' | translate }}:
    </span>
    {{ user.numberFinishedJobs }}
  </div>
  <div class="card-items">
    <div class="action-mobileView">
      <span class="mobileViewHint"
        >{{ 'adminusers.action' | translate }}:
      </span>
      <div class="action-mobileView-buttons" (click)="$event.stopPropagation()">
        <i class="material-icons action-buttons" (click)="editUser(user)"
          >edit</i
        >
        <i class="material-icons action-buttons" (click)="deactivate(user)"
          >build</i
        >
        <i class="material-icons action-buttons" (click)="deleteUser(user)"
          >delete</i
        >
      </div>
    </div>
  </div>
</mat-card>
